comment #
*************************************************
*						*
*    `uqC^@eXgvO		*
*						*
*	1999.6.13  		   		*
*						*
*************************************************

#

include	stddef.inc
include	str.inc
include	file.inc
include	ibmpc.inc


.model t
.186
;-----------------------------------------------------------------------------
; f[^̈̒`

.data

MessOpn		db	'AVRXCHK - AVRX function check program',CR,LF,'$'
MessNoLpt	db	LF,'No LPT port in this system.',CR,LF,'$'
MessNoAvr	db	LF,'AVRX adapter not attached on LPT1.',CR,LF,'$'

MesOutp	db	CR,LF,LF
	db	'[OUTPUT TEST]                      [<-]/[->] - Move cursor',CR,LF
	db	'20  5   7   9   13  15  17  19     [Space]   - Toggle',CR,LF
	db	'| 1 | 6 | 8 | 12| 14| 16| 18|      [Enter]   - Enter INPUT TEST',CR,LF
	db	'| | | | | | | | | | | | | | |      [Esc]     - Exit',CR,LF
	db	'$'

MesInp	db	CR,LF,LF
	db	'[INPUT TEST]',CR,LF
	db	'3   13  15  17  19',CR,LF
	db	'| 12| 14| 16| 18|',CR,LF
	db	'| | | | | | | | |      Enter  - Exit',CR,LF
	db	'$'


B_STB		equ	BIT0	; LPT f[^rbg蓖
B_OE		equ	BIT1
B_WR		equ	BIT2
B_BS		equ	BIT3
B_XA0		equ	BIT4
B_SDAT		equ	BIT4
B_XA1		equ	BIT5
B_SCLK		equ	BIT6
B_CHK		equ	BIT7
B_SCMD		equ	BIT7

S_PE		equ	BIT5	; LPT Xe[^Xrbg蓖
S_ACK		equ	BIT6
S_BUSY		equ	BIT7

B_VCC		equ	BIT1	; LPT rbg蓖
B_VPP		equ	BIT0	

LptBase		dw	?		; LPT1 ̃AhX
LptData		db	00000000b	; LPT1 f[^WX^o͒l
LptCtrl		db	00001111b	; LPT1 䃌WX^o͒l
SftReg		db	0		; VtgWX^o̓f[^

BitPtr		db	1	; rbgʒu (1..7,8..15)



;-----------------------------------------------------------------------------
; vOR[h
;-----------------------------------------------------------------------------

.code
		DEF_PSP
start:
		PRINT  MessOpn
		 call	initial		; C^

		 call	test_out	; o̓eXg
		cje	al,ESC, quit

		 call	test_in		; ̓eXg

quit:		$DOS	4ch,0		; I



;--------------------------------------;
; o̓eXg

test_out:
		PRINT	MesOutp
	_while
		 call	set_out
		 call	disp_out
		$KEY  0
	 _break e, al,CR	; Enter
	 _break e, al,ESC	; Esc

	 _case e, ax,4d00h	; 
	  _if b, BitPtr,15
		inc	BitPtr
	  _endif

	 _case e, ax,4b00h	; 
	  _if a, BitPtr,1
		dec	BitPtr
	  _endif

	 _case e, al,' '	; Space
		mov	cl,BitPtr
		mov	al,BIT0
	  _if ae, cl,8
		rol	al,cl
		xor	SftReg,al
	  _else
	   _if ae, cl,3
		sub	cl,3
		rol	al,cl
		xor	LptData,al
	   _else
		dec	cl
		mov	al,BIT1
		ror	al,cl
		xor	LptCtrl,al
	  __endif

	 _endc
	_rept
		ret


set_out:
		mov	dx,LptBase
		mov	al,LptData
		mov	ah,SftReg
	_repeat 8
		res	al,B_SCMD+B_SCLK+B_SDAT
		rol	ah,1
	 @if c,<set	al,B_SDAT>
		out	dx,al
		set	al,B_SCLK
		out	dx,al
	_loop
		mov	al,LptData
		out	dx,al
		incw	dx
		mov	al,LptCtrl
		out	dx,al
		ret


disp_out:
		mov	al,CR
		int	29h
		mov	bl,LptCtrl
		ror	bl,2
		rol	bl,1
		cmc
		 call	do_bit
		rol	bl,1
		cmc
		 call	do_bit
		mov	bl,LptData
	_repeat 5
		shr	bl,1
		 call	do_bit
	_loop
		mov	bl,SftReg
	_repeat 8
		shr	bl,1
		 call	do_bit
	_loop
		mov	cl,BitPtr
	_repeat
		mov	al,BS
		int	29h
		int	29h
		inc	cl
	_rept b, cl,16
		ret

do_bit:		mov	al,'L'
	 @if c,<mov	al,'H'>
		int	29h
		mov	al,' '
		int	29h
		ret



;--------------------------------------;
; ̓eXg

test_in:
		PRINT	MesInp
		mov	LptData,00000000b
		mov	LptCtrl,00001101b
		 call	set_out
		mov	si,-1
	_while
	 _while
		 call	read_in
	  _break ne, bx,si
		$KEY  1
	  _cont z
		$KEY  0
		ret
	 _rept
		mov	si,bx
		 call	disp_in
	_rept


read_in:
		mov	dx,LptBase
		mov	al,LptData
		res	al,B_SCLK+B_SDAT
		set	al,B_SCMD
		out	dx,al
		set	al,B_SCLK
		out	dx,al
		res	al,B_SCMD+B_SCLK
		out	dx,al
	_repeat 8
		shl	bl,1
		inc	dx
		mov	ah,al
		in	al,dx
		dec	dx
		test	al,S_ACK
	 @ifn z,<set	bl,BIT0>
		mov	al,ah
		res	al,B_SCLK+B_SCMD+B_SDAT
		out	dx,al
		set	al,B_SCLK
		out	dx,al
	_loop
		inc	dx
		in	al,dx
		shr	al,7
		not	al
		and	al,1
		mov	bh,al
		ret


disp_in:
		mov	al,CR
		int	29h
		shr	bh,1
		 call	di_bit
	_repeat 8
		shr	bl,1
		 call	di_bit
	_loop
		ret
di_bit:		mov	al,'L'
	 @if c,<mov	al,'H'>
		int	29h
		mov	al,' '
		int	29h
		ret



;--------------------------------------;
; C^(LPT1AhX擾)

initial:
		movseg	es,SEG_BIOS
		mov	ax,es:BiosLptLst[0]
		movseg	es,cs
	_if e, ax,0
		PRINT  MessNoLpt
		$DOS  4ch,1
	_endif
		mov	LptBase,ax
		outb	LptBase,B_CHK
		inc	dx
		in	al,dx
		test	al,S_PE
		jz	ie_na
		outb	LptBase,0
		inc	dx
		in	al,dx
		test	al,S_PE
		jnz	ie_na
		ret
	ie_na:	PRINT  MessNoAvr
		$DOS  4ch,1


;--------------------------------------;

		$end	start

